#include <stdlib.h>
#include "huffman.h"

struct tree *make_tree(int value, int letter, struct tree *left, struct tree *right)
{
    struct tree *l = malloc(sizeof(*l));
    l->value = value;
    l->letter = letter;
    l->left = left;
    l->right = right;
    return l;
}

void free_tree(struct tree *root)
{
    if (root->left)
        free_tree(root->left);
    if (root->right)
        free_tree(root->right);
    root->left = root->right = NULL;
    free(root);
};

int is_leaf(const struct tree *t)
{
    return t->left == NULL && t->right == NULL;
}

struct tree *make_leaf(int value, unsigned char letter)
    ;

static struct tree *make_node(struct tree *left, struct tree *right)
    ;

/**
 * Create a forest (i.e., an array of tree) associating each possible byte
 * to its frequency.
 * Returns the number of letters associated this way.
 */
static int make_letters(const int freq[], struct tree *letters[])
    ;

/**
 * Find the index of the tree with the lowest frequency
 * Prefer tree over letters
 */
static int index_min(int size, struct tree *letters[])
    ;

struct tree *make_huffman_tree(int freq[])
    ;

// TODO
int rank(const struct tree *node)
;

// TODO
const struct tree *find_right_most_leaf(const struct tree *node)
;


